#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>

void lper(char *ffname, int lno, char *fmt,...)
{
  va_list args;

  va_start(args, fmt);
  fprintf(stderr,"'%s' line %d:", ffname, lno);
  vfprintf(stderr, fmt, args);
  va_end(args);
  fprintf(stderr,"\n");
  exit(-1);
}


int isvarchr(int ch)
{
  ch=toupper(ch);
  return ((ch>='A' && ch<='Z') || ch=='_');
}

int isdig(int ch)
{
  return (ch>='0' && ch<='9');
}

int isvardig(int ch)
{
  return (isvarchr(ch)||isdig(ch));
}

int ispc(char c)
{
  return (c==' ' || c==9);
}

char *skip_spc(char *s)
{
  while (*s==' '||*s==9) s++;
  return s;
}

char *to_spc(char *s)
{
  while (*s!=' ' && *s!=9 && *s && *s!='\n') s++;
  return s;
}

int hex2b(char h)
{
  return (h>='a'?h-'a'+10:h-'0');
}

void mkstr(char *aa,char *bb,char *tt)
{
  int len;
  memcpy(tt,aa,len=bb-aa);
  tt[len]=0;
}

char *varname(char *s,char *fn)
{
  char *t;
  t=s=skip_spc(s);
  if (!isvarchr(*s)) return 0;
  while (isvarchr(*t)||isdig(*t)) t++;
  mkstr(s,t,fn);
  return t;
}


char *varname_sh(char *s,char *fn)
{
  char *t;
  char uu[256];
  char *env;

  t=s+1;
  if (!isvarchr(*t)) {
skip:
    strcpy(fn,"$");
    return s+1;
  }
  while (isvarchr(*t)||isdig(*t))
    t++;
  mkstr(s+1,t,uu);

  if ((env=getenv(uu))) {
    strcpy(fn,env);
    return t;
  } else
    goto skip;
}

char *parse_Cstr(char *ffname, int lno, char *ss, char **end)
{
  static char tt[1024];
  int sl=0;
  if (*ss!='"') lper(ffname,lno,"Bad string %s",ss);
  ss++;
  while (*ss && *ss!='"') {
    if (*ss=='\\') {
      switch (*(ss+1)) {
        case 'n':
          tt[sl++]='\n';
          ss+=2;
          continue;
        case 'r':
          tt[sl++]='\r';
          ss+=2;
          continue;
        case '\\':
          tt[sl++]='\\';
          ss+=2;
          continue;
        case 't':
          tt[sl++]='\t';
          ss+=2;
          continue;
        case '"':
          tt[sl++]='"';
          ss+=2;
          continue;
        case 'v':
          tt[sl++]='\v';
          ss+=2;
          continue;
        case 'f':
          tt[sl++]='\f';
          ss+=2;
          continue;
        case 'a':
          tt[sl++]='\a';
          ss+=2;
          continue;
        case 'e':
          tt[sl++]=27;
          ss+=2;
          continue;
        case 'x':
          ss+=2;
          tt[sl++]=(hex2b(*ss)<<4)+hex2b(*(ss+1));
          ss+=2;
          continue;
        case '$':
          tt[sl++]='$';
          ss+=2;
          continue;
      }
    } else
    if (*ss=='$') {
      char uu[1024];
      int l;
      ss=varname_sh(ss,uu);
      l=strlen(uu);
      memcpy(&tt[sl],uu,l);
      sl+=l;
      continue;
    }
    tt[sl++]=*(ss++);
  }
  if (!(*ss)) lper(ffname,lno,"\" expected");
  tt[sl]=0;
  *end=ss+1;
  return tt;
}


char *toCstr(char *s)
{
  char tt[256];
  int ttlen=0;

  tt[ttlen++]='"';

  while (*s) {
    char c = *s;

    if (c=='"') {
      tt[ttlen++]='\\';
      tt[ttlen++]='"';
    } else
    if (c=='\\') {
      tt[ttlen++]='\\';
      tt[ttlen++]='\\';
    } else
      tt[ttlen++]=c;

    s++;
  }

  tt[ttlen++]='"';
  tt[ttlen]=0;

  return strdup(tt);
}
