#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <unistd.h>
#include <stdlib.h>
#include <gtk/gtk.h>

#include "reminder.h"
#include "fftv.h"

int rem_sockfd;

char *get_fftv_sock_path();

void init_rem_serv()
{
  struct sockadd_un;
  struct sockaddr_un serv_addr;
  int servlen;

  bzero((char *) &serv_addr,sizeof(serv_addr));
  serv_addr.sun_family = AF_UNIX;
  strcpy(serv_addr.sun_path, get_fftv_sock_path());
  servlen = strlen(serv_addr.sun_path) + sizeof(serv_addr.sun_family);

  printf("-- %s\n",serv_addr.sun_path);
  unlink(serv_addr.sun_path);

  if ((rem_sockfd = socket(AF_UNIX,SOCK_STREAM,0)) < 0) {
    perror("cannot open socket");
    exit(-1);
  }

  if (bind(rem_sockfd, (struct sockaddr *) &serv_addr, servlen) < 0) {
    perror("cannot bind");
    exit(-1);
  }

  listen(rem_sockfd,2);
//  printf("rem_sockfd: %d\n",rem_sockfd);
}


void read_reminder_msg(REMINDER *premind)
{
   int newsockfd,clilen;
   struct sockaddr_un cli_addr;

   bzero(&cli_addr, sizeof(cli_addr));
   clilen=0;
   newsockfd = accept(rem_sockfd,(struct sockaddr *) & cli_addr, &clilen);
   if (newsockfd < 0) {
     perror("accept");
     return;
   }

   read(newsockfd, premind,sizeof(REMINDER));

   if (premind->channel_name[0])
     printf("reminder channel %s  %s\n",premind->channel_name,premind->program_name);
   close(newsockfd);
}


void close_rem_srv()
{
  close(rem_sockfd);
}

extern GtkWidget *gtv_win;

void read_reminder_msg(REMINDER *premind);
void draw_reminder_message(char *str);
void preview_select_channel();
void reset_sreensaver();
void save_channel_name_last_session(char *chname);

void reminder_callback(gpointer data, gint source, GdkInputCondition condition)
{
   REMINDER reminder;

   dbg("--- reminder_callback\n");

   reset_sreensaver();

   if (tv_preview_mode) {
     preview_select_channel();
   }

   bzero(&reminder,sizeof(reminder));

   read_reminder_msg(&reminder);

   if (fftv_mode != reminder.fftv_mode) {
     save_channel_name_last_session(reminder.channel_name);
     tv_fm_switch();

     if (fftv_mode & FFTV_MODE_TV)
       draw_reminder_message(reminder.program_name);

     return;
   }

   if (fftv_mode & FFTV_MODE_TV)
     gtk_window_present(GTK_WINDOW(gtv_win));

   if (reminder.channel_name[0])
     set_channel_by_name(reminder.channel_name);

   if (reminder.program_name[0] && (fftv_mode & FFTV_MODE_TV)) {
     draw_reminder_message(reminder.program_name);
   }
}
