#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <linux/videodev.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/time.h>
#include <time.h>
#include <pthread.h>

#include <string.h>
#include <ctype.h>
#include <gtk/gtk.h>

#include "tv-freq.h"
#include "fftv.h"

#define NO_TV (0)
void putStr(char *s, int x, int y);


extern int chan_idx;
extern int vfd;

static int freq_tunded()
{
  struct video_tuner tuner;

  if (-1 == ioctl(vfd,VIDIOCGTUNER,&tuner))
    return 0;
  return tuner.signal ? 1 : 0;
}


extern char fftv_freq[],ffradio_conf[];
void set_channel_chan_idx();

extern GtkWidget *gtv_win;

void scan_loop(int clidx)
{
  int i;
  CHANLIST *clist=chanlists[clidx].list;
  int clistN=chanlists[clidx].count;
  FILE *fp;
  char fftv_freq_sys[128];
  struct stat st;

#if 0
  chanlist=clist;
  chanlistN=clistN;
#endif

  dbg("clidx:%d\n",clidx);

  for(i=0;i<clistN;i++) {
    clist[i].flag&=~CHAN_SELECT;
  }

  dbg("clistN:%d\n",clistN);
  tv_audio_off();


  for(i=0;i<clistN;i++) {
#if 0
    set_chan_idx(i);
    set_channel_chan_idx();
#else
    set_channel_pch_0(&clist[i]);
#endif
    usleep(500000);

    if (!freq_tunded())
      continue;

    gtk_window_set_title(GTK_WINDOW(gtv_win), clist[i].name);

    clist[i].flag|=CHAN_SELECT;

    process_gtk_events();
  }

  if (stat(fftv_freq, &st) && mkdir(fftv_freq,0755)) {
    perror(fftv_freq);
    exit(-1);
  }

#if 1
  strcat(strcpy(fftv_freq_sys,fftv_freq),"/.system");

  if ((fp=fopen(fftv_freq_sys,"w"))==NULL)
    p_err("cannot create %s",fftv_freq_sys);

  fprintf(fp,"%s\n",chanlists[clidx].name);
  fclose(fp);
#endif

  for(i=0;i<clistN;i++) {
    char fftv_freq_channel[128];
    sprintf(fftv_freq_channel,"%s/%d",fftv_freq,clist[i].rno);

    if (!(clist[i].flag&CHAN_SELECT)) {
      unlink(fftv_freq_channel);
      continue;
    }

    if (!access(fftv_freq_channel,R_OK))
      continue;

    if ((fp=fopen(fftv_freq_channel,"w"))==NULL)
      p_err("cannot create %s",fftv_freq_channel);
    fprintf(fp,"%d 0\n%s",clist[i].freq,clist[i].name);
    fclose(fp);
  }

}


void load_chanlist();
void set_vwin_0();
void tv_pic_off();
int get_tv_sys();

void scan_channel()
{
  int tv_sys_idx=-1;

  tv_sys_idx = get_tv_sys();

  if (tv_sys_idx < 0)
    return;

  dbg("tv_sys_idx: %d\n",tv_sys_idx);

  process_gtk_events();

  scan_loop(tv_sys_idx);

  load_chanlist();
  set_chan_idx(0);
  set_channel_chan_idx();

}
