#include <glib.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include "tv-freq.h"

static GtkWidget *tv_sys_window = NULL;

int new_select_idx;

static gboolean close_application( GtkWidget *widget,
                                   GdkEvent  *event,
                                   gpointer   data )
{
  new_select_idx = -1;
  gtk_widget_destroy(tv_sys_window);
  gtk_main_quit();

  return FALSE;
}


static gboolean cb_ok( GtkWidget *widget,
                                   GdkEvent  *event,
                                   gpointer   data )
{
  printf("--- close with %d\n",new_select_idx);
  gtk_widget_destroy(tv_sys_window);
#if 1
  tv_sys_window = NULL;
  gtk_main_quit();
#endif

  return FALSE;
}


static void callback_button_clicked( GtkWidget *widget, gpointer data)
{
//  printf("selected %d\n", data);
  new_select_idx = (int) data;
}

extern GtkWidget *gtv_win;

void create_tv_sys_window()
{
    GtkWidget *box1;
    GtkWidget *box2;
    GtkWidget *button, *button_close;
    GtkWidget *separator;
    GtkWidget *frame;

    tv_sys_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
#if 0
    gtk_window_set_modal(tv_sys_window, TRUE);
    gtk_window_set_transient_for(GTK_WINDOW(tv_sys_window), GTK_WINDOW(gtv_win));
#endif

    g_signal_connect (G_OBJECT (tv_sys_window), "delete_event",
                      G_CALLBACK (close_application),
                      NULL);

    gtk_window_set_title (GTK_WINDOW (tv_sys_window), "TV system");
    gtk_container_set_border_width (GTK_CONTAINER (tv_sys_window), 3);

    frame = gtk_frame_new("Select a TV system");
    gtk_container_add (GTK_CONTAINER (tv_sys_window), frame);


    box1 = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (frame), box1);

    box2 = gtk_vbox_new (FALSE, 10);
    gtk_container_set_border_width (GTK_CONTAINER (box2), 10);
    gtk_box_pack_start (GTK_BOX (box1), box2, TRUE, TRUE, 0);

    int i;
    GSList *group=NULL;

    extern int fftv_system_chanlists_idx();

    int current_idx = fftv_system_chanlists_idx();

    if (current_idx == chanlistsN)
      current_idx = 0;

    new_select_idx = current_idx;

    for(i=0;i<chanlistsN;i++) {
      button = gtk_radio_button_new_with_label (group, chanlists[i].name);
      gtk_box_pack_start (GTK_BOX (box2), button, TRUE, TRUE, 0);

      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (button));

      g_signal_connect (G_OBJECT (button), "clicked",
         G_CALLBACK (callback_button_clicked), (gpointer) i);

      if (i==current_idx)
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
    }

    separator = gtk_hseparator_new ();
    gtk_box_pack_start (GTK_BOX (box1), separator, FALSE, TRUE, 0);

    box2 = gtk_vbox_new (FALSE, 10);
    gtk_container_set_border_width (GTK_CONTAINER (box2), 10);
    gtk_box_pack_start (GTK_BOX (box1), box2, FALSE, TRUE, 0);

    button_close = gtk_button_new_with_label ("OK");
    g_signal_connect_swapped (G_OBJECT (button_close), "clicked",
                              G_CALLBACK (cb_ok),
                              G_OBJECT (tv_sys_window));
    gtk_box_pack_start (GTK_BOX (box2), button_close, TRUE, TRUE, 0);
    GTK_WIDGET_SET_FLAGS (button_close, GTK_CAN_DEFAULT);
    gtk_widget_grab_default (button_close);

    gtk_widget_show_all (tv_sys_window);

    return;
}


int get_tv_sys()
{

  create_tv_sys_window();

  gtk_main();

  return new_select_idx;
}
